<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.6                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2015                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_ping extends cmsPlugin {

    public function __construct(){

        // Информация о плагине
        $this->info['plugin']      = 'p_ping';
        $this->info['title']       = 'Пинг поисковых систем';
        $this->info['description'] = 'Пингует Яндекс и Гугл при добавлении статей, объявлений и постов в блоги';
        $this->info['author']      = 'InstantCMS Team';
        $this->info['version']     = '1.10';

        // Настройки по-умолчанию
        $this->config['Yandex HOST'] = 'ping.blogs.yandex.ru';
        $this->config['Yandex PATH'] = '/RPC2';
        $this->config['Google HOST'] = 'blogsearch.google.com';
        $this->config['Google PATH'] = '/ping/RPC2';

        // События, которые будут отлавливаться плагином
        $this->events[] = 'ADD_POST_DONE';
        $this->events[] = 'ADD_ARTICLE_DONE';
        $this->events[] = 'ADD_BOARD_DONE';

        parent::__construct();

    }

// ==================================================================== //
    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event='', $item=array()){

        switch ($event){

            case 'ADD_POST_DONE':
                $pageURL = HOST . $item['seolink'];
                $feedURL = HOST . '/rss/blogs/all/feed.rss';
                $this->ping($pageURL, $feedURL);
            break;

            case 'ADD_ARTICLE_DONE':
                $pageURL = HOST .'/'. $item['seolink'] . '.html';
                $feedURL = HOST . '/rss/content/all/feed.rss';
                $this->ping($pageURL, $feedURL);
            break;    

            case 'ADD_BOARD_DONE':
                $pageURL = HOST . '/board/read'.$item['id'].'.html';
                $feedURL = HOST . '/rss/board/all/feed.rss';
                $this->ping($pageURL, $feedURL);

            break;

        }

        return $item;

    }

// ==================================================================== //

    private function ping($pageURL, $feedURL) {

        $inConf = cmsConfig::getInstance();
		$inUser = cmsUser::getInstance();
        global $_LANG;

        require_once(PATH.'/plugins/p_ping/IXR_Library.php');

        $siteName = $inConf->sitename;
        $siteURL  = HOST.'/';

        $result   = array();

       if ($this->config['serv']){
       
        $serv =  strip_tags($this->config['serv'],'<br>');
       
        $explode = explode('<br/>', $serv);
                        
        foreach ($explode as $line) {
                              
    if (!preg_match("/http/i", $line)) {
        $line = 'http://' . $line;
    } 
                         
       $parse = parse_url(trim($line));  
                 
            $pingClient = new IXR_Client($parse['host'], $parse['path']); 
          
            // Посылаем запрос

       if (!$pingClient->query('weblogUpdates.ping', $siteName, $siteURL, $pageURL,$feedURL)) {
        $result[] =  'Ошибка ping-запроса '.$parse['host'] . $parse['path'].'[' .
        $pingClient->getErrorCode() . '] ' . $pingClient->getErrorMessage() . '<br />';
    } else {
        $result[] = 'Послан ping: ' . $parse['host'] . $parse['path'] . ' | ' . $pageURL . '<br />';
    } 

			unset($pingClient);

        } 
        
        }


		if($inUser->is_admin && $result){
        	cmsCore::addSessionMessage(implode(', ', $result), 'info');
		}

        return;

    }

// ==================================================================== //

}